local L = LibStub("AceLocale-3.0"):GetLocale("AVRE", false)
local AVRE = AVRE
local mod = AVRE:NewModule("Options", "AceConsole-3.0")
local zones = LibStub("AceLocale-3.0"):GetLocale("AVRE Zones")



local newOrder
do
	local current = 0
	function newOrder()
		current = current + 1
		return current
	end
end

local newExpansion
local newInstance
local newFight
local a
local b
local c

function newExpansion(n, s)
	a = s
	return n
end

function newInstance(n, s)
	b = s
	return n
end

function newFight(n, s)
	c = s
	return n
end

function checkbox_spell(a, b, c, spellId, message, option)
	return {
		type = "toggle",
		name = GetSpellInfo(spellId),
		desc = format(message, GetSpellInfo(spellId)),
		get = function() return AVRE.db.profile.enc[a][b][c][option] end,
		set = function(self, val) AVRE.db.profile.enc[a][b][c][option] = val end,
		order = newOrder(),
	}
end



--[[
      OPTIONS ------------------------------------------------------------------------------------------------------------------
  ]]

local debugMsg = ""
--[===[@debug@
debugMsg = "    (running in debug mode)"
--@end-debug@]===]

AVRE.options = {
	name = "AVR Encounters         r|cff20ff20"..AVRE.MINOR_VERSION.."|r"..debugMsg,
	handler = VampArrow,
	type = "group",
	args = {		

		enabled = {
			type = "toggle",
			name = L["Enable AVR Encounters"],
			get = function() return AVRE.db.profile.enabled end,
			set = function(self, val)
				AVRE.db.profile.enabled = val
				if val then AVRE:Enable() else AVRE:Disable() end
			end,
			order = newOrder(),
		}, -- enabled
		
		wotlk = {
			name = newExpansion(L["Wrath of the Lich King"], "wotlk"),
			type = "group",
			order = newOrder(),
			args = {
			
				enabled = {
					type = "toggle",
					name = L["Enable Expansion"],
					get = function() return AVRE.db.profile.enc.wotlk.enabled end,
					set = function(self, val) AVRE.db.profile.enc.wotlk.enabled = val end,
					order = newOrder(),
				}, -- enabled

				icecrown = {
					name = newInstance(zones["Icecrown Citadel"], "icecrown"),
					type = "group",
					order = newOrder(),
					args = {
						
						enabled = {
							type = "toggle",
							name = L["Enable Raid Instance"],
							get = function() return AVRE.db.profile.enc.wotlk.icecrown.enabled end,
							set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.enabled = val end,
							order = newOrder(),
						}, -- enabled
						
						
-- LORD MARROWGAR --------------------------------------------------------------------------------------------------

						marrowgar = {
							name = newFight(L["Lord Marrowgar"], "marrowgar"),
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.marrowgar.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.marrowgar.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								spike = checkbox_spell(a,b,c, 69062, L["Places a circle under players with %s, along with a marker line toward them."], "spike"),
								
							},
						},
						
						
-- LADY DEATHWHISPER -----------------------------------------------------------------------------------------------

						deathwhisper = {
							name = newFight(L["Lady Deathwhisper"], "deathwhisper"),
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.deathwhisper.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.deathwhisper.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								spike = checkbox_spell(a,b,c, 71289, L["Places a circle under players with %s."], "dominate"),
								spirit = checkbox_spell(a,b,c, 71426, L["Places a circle under players with %s."], "spirit"),
								
							},
						},
						
						
-- FESTERGUT -------------------------------------------------------------------------------------------------------

						festergut = {
							name = newFight(L["Festergut"], "festergut"),
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.festergut.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.festergut.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								gasSpore = checkbox_spell(a,b,c, 69279, L["Places a circle under players with %s."], "gasSpore"),
								
							},
						},
						
						
-- ROTFACE ---------------------------------------------------------------------------------------------------------

						rotface = {
							name = newFight(L["Rotface"], "rotface"),
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.rotface.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.rotface.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								explosion = checkbox_spell(a,b,c, 69839, L["Places a circle under all players during %s."], "explosion"),
								
							},
						},
						
						
-- PUTRICIDE -------------------------------------------------------------------------------------------------------

						putricide = {
							name = newFight(L["Professor Putricide"], "putricide"),
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.putricide.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.putricide.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								malleable = checkbox_spell(a,b,c, 72615, L["Places a circle under players with %s."].." "..L["Only works for one of the players."], "malleable"),
								plague = checkbox_spell(a,b,c, 72855, L["Places a circle under players with %s."], "plague"),
								sick = checkbox_spell(a,b,c, 70953, L["Places a circle under players with %s."], "sick"),
								
							},
						},
						
						
-- BLOOD PRINCE COUNCIL --------------------------------------------------------------------------------------------

						bloodprince = {
							name = newFight(L["Blood Prince Council"], "bloodprince"),
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.bloodprince.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.bloodprince.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								flame = {
									type = "toggle",
									name = GetSpellInfo(72040),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(72040)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.bloodprince.flame end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.bloodprince.flame = val end,
									order = newOrder(),
								},
								
								vortex = {
									type = "toggle",
									name = GetSpellInfo(72037),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(72037)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.bloodprince.vortex end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.bloodprince.vortex = val end,
									order = newOrder(),
								},
								
							},
						},
						
						
-- SINDRAGOSA ------------------------------------------------------------------------------------------------------

						sindragosa = {
							name = newFight(L["Sindragosa"], "sindragosa"),
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.sindragosa.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.sindragosa.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								beacon = {
									type = "toggle",
									name = GetSpellInfo(70126),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(70126)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.sindragosa.beacon end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.sindragosa.beacon = val end,
									order = newOrder(),
								},
								
								unchained = {
									type = "toggle",
									name = GetSpellInfo(69762),
									desc = format(L["Places a circle under players with %s."].." "..L["(Heroic mode only.)"], GetSpellInfo(69762)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.sindragosa.unchained end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.sindragosa.unchained = val end,
									order = newOrder(),
								},
								
							},
						},
						
						
-- LICH KING -------------------------------------------------------------------------------------------------------

						lichking = {
							name = newFight(L["The Lich King"], "lichking"),
							type = "group",
							order = newOrder(),
							args = {
							
								enabled = {
									type = "toggle",
									name = L["Enable Encounter"],
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.lichking.enabled end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.lichking.enabled = val end,
									order = newOrder(),
								}, -- enabled
								
								header = {
									type = "header",
									name = "",
									order = newOrder(),
								},
							
								defile = {
									type = "toggle",
									name = GetSpellInfo(72762),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(72762)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.lichking.defile end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.lichking.defile = val end,
									order = newOrder(),
								},
								
								shadowtrap = {
									type = "toggle",
									name = GetSpellInfo(73539),
									desc = format(L["Places a circle under players with %s."], GetSpellInfo(73539)),
									get = function() return AVRE.db.profile.enc.wotlk.icecrown.lichking.shadowtrap end,
									set = function(self, val) AVRE.db.profile.enc.wotlk.icecrown.lichking.shadowtrap = val end,
									order = newOrder(),
								},
								
							},
						},
						
						
					},
				},
				
			},
		},

	}
}



--[[
      INITIALIZATION -----------------------------------------------------------------------------------------------------------
  ]]

function mod:OnInitialize()
	-- Register options
	LibStub("AceConfig-3.0"):RegisterOptionsTable("AVRE", AVRE.options)
	AVRE.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("AVRE", "AVR Encounters")
	LibStub("AceConfig-3.0"):RegisterOptionsTable("AVRE-Profiles", LibStub("AceDBOptions-3.0"):GetOptionsTable(AVRE.db))
	AVRE.profilesFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("AVRE-Profiles", "Profiles", "AVR Encounters")
	AVRE.modules.options.loaded = true
end


function mod:OnEnable()
--[===[@debug@
	self:Print(L["Loaded"])
--@end-debug@]===]
end
